<template>
  <div>
    <q-table
      grid
      title="Projects"
      :rows="rows"
      :columns="columns"
      row-key="name"
      :filter="filter"
      hide-header
    >
      <template v-slot:top-right>
        <q-input borderless dense debounce="300" v-model="filter" placeholder="Search">
          <template v-slot:append>
            <q-icon name="search" />
          </template>
        </q-input>
      </template>

      <template v-slot:item="props">
        <div class="q-pa-xs col-xs-10 col-sm-6 col-md-4">

          <q-card flat bordered class="my-card">
            <q-card-section>
              <div class="row items-center no-wrap">
                <div class="col">
                  <div class="text-h6"><a :href="props.row.gitlab_url" target="_new"><q-icon v-if="props.row.gitlab_url" name="fab fa-gitlab" color="grey"/></a>&nbsp;
                   <router-link
                     :to="{ name: 'ProjectDetails',
                            params: { id: props.row.id }}">{{ props.row.name }}</router-link>
                   </div>
                </div>

                <div class="col-auto">
                  <q-btn color="grey-7" round flat icon="more_vert">
                    <q-menu cover auto-close>
                      <q-list>
                        <q-item clickable>
                          <q-item-section>Remove Project</q-item-section>
                        </q-item>
                      </q-list>
                    </q-menu>
                  </q-btn>
                </div>
              </div>
            </q-card-section>

            <q-separator />
            <!--
            <q-card-section>
              <div class="text-caption text-grey">{{ props.row.description }}</div>
            </q-card-section>
            -->

            <q-card-section>
              <statsIcon icon="fas fa-vial" :title="props.row.tests_length.toString()" caption="Tests found so far" />
              <statsIcon icon="fas fa-running" :title="props.row.runners_length.toString()" caption="External runners" />
              <statsIcon 
                icon="far fa-clock"
                :title="props.row.latest_pipeline.status"
                :caption="getRelativeDate(props.row.latest_pipeline.created_at)"
                :alt="props.row.latest_pipeline.created_at"
                :href="props.row.latest_pipeline.web_url"
                :color="getStatusColor(props.row.latest_pipeline.status)"
                v-if="props.row.latest_pipeline"/>
              <statsIcon icon="far fa-clock" title="UNKNOWN" caption="Latest pipeline is unknown" color="negative" v-else/>
              <statsIcon icon="fas fa-bacteria" title="1%" caption="Flakiness level" color="positive" />
            </q-card-section>


            <!--
            <q-card-actions>
              <q-btn flat>Action 1</q-btn>
              <q-btn flat>Action 2</q-btn>
            </q-card-actions>
            -->
          </q-card>

        </div>
      </template>

    </q-table>
  </div>
</template>

<script>
import { ref } from 'vue'
import statsIcon from '@/components/statsIcon.vue'

const conf = config()

const columns = [
  { name: 'id', sortable: false },
  {
    name: 'name',
    required: true,
    label: 'Name',
    align: 'left',
    sortable: true,
  },
  { name: 'description', sortable: false },
  { name: 'gitlab_url', sortable: false },
  { name: 'tests_length', sortable: true },
  { name: 'runners_length', sortable: true },
  { name: 'latest_pipeline', sortable: false }
]


export default {
  setup () {
    return {
      filter: ref(''),
      columns
    }
  },

  components: {
    statsIcon
  },
  data () {
    return {
       rows: [],
       gitlabProjectDetails: {}
    }
  },
  mounted () {
    fetch(conf.I4C_API_SERVER + "/projects/")
      .then(response => response.json())
      .then(data => (this.update(data)));
  },
  methods: {
    getStatusColor(status) {
       const colors = {'failed': 'negative',
                       'success': 'positive'}
       return colors[status]
    },
    getRelativeDate(value) {
       const date = new Date(value)
       const deltaDays = (date.getTime() - Date.now()) / (1000 * 3600 * 24)
       const formatter = new Intl.RelativeTimeFormat()
       return formatter.format(Math.round(deltaDays), 'days')
    },
    update(data) {
       let self = this

       data.forEach(function(project) {
          self.rows.push({'id': project.id,
                          'name': project.name,
                          'description': project.description,
                          'tests_length': project.tests_length,
                          'runners_length': project.runners_length,
                          'gitlab_url': project.gitlab_url,
                          'latest_pipeline': project.latest_pipeline})
       })
       console.log(this.gitlabProjectDetails)
    }
  }
}
</script>

<style>
.my-card {
  min-height: 320px;
}
</style>
